Type TServer
	As String nam,ip
	As String aliasname,ports(10),checkport(10)
	As Double pings(100),httppings(100)
	As String pingstime(100),httppingstime(100)
	As String gethttp
	As Integer pingtimer
	As Byte up,pinginterval,graph
	Declare Sub Refresh()
	Declare Sub DrawWin(y As UShort)
	Declare Sub Ping()
	Declare Sub HTTP()
	Declare Function CheckPorts(check As String)As UByte
End Type

Dim Shared As UByte server_anzahl
Dim Shared As String terminal,proxy

Sub TServer.Refresh()
	Dim As String lin
	Dim As UByte count
	Var ff=FreeFile
	Open Pipe "nslookup "+nam For Input As #ff
		Do Until Eof(ff)
			Line Input #ff,lin
			If Instr(lin,"Address: ") Then
				ip=Mid(lin,10)
			Elseif Instr(lin,"canonical name = ") Then
				aliasname=Mid(lin,Instr(lin,"canonical name = ")+17)
			End If
		Loop
	Close #ff
	
	ff=FreeFile
	Open Pipe "nmap "+nam For Input As #ff
		Do Until Eof(ff)
			Line Input #ff,lin
			If (Instr(lin,"/tcp") Or Instr(lin,"/udp")) And count<8 Then
				up=1
				count+=1
				If count<8 Then ports(count)=lin
			Elseif Instr(lin,"21/tcp    open   ftp") And count>=8 Then 
				ports(7)=lin
			ElseIf Instr(lin,"22/tcp    open   ssh") And count>=8 Then 
				ports(8)=lin
			Elseif Instr(lin,"Note: Host seems down.") Then
				up=0
			End If
		Loop
	Close #ff
End Sub

Sub TServer.Ping()
	Dim As String lin
	Dim As UByte count
	Var ff=FreeFile
	Open Pipe "ping "+nam+" -c 1 -W 1" For Input As #ff
		Do Until Eof(ff)
			Line Input #ff,lin
			If Instr(lin,"time=") Then
				'pings(99)=pings(100)
				For i As Integer=1 To 99
					pings(i)=pings(i+1)
					pingstime(i)=pingstime(i+1)
				Next
				pings(100)=Val(Mid(lin,Instr(lin,"time=")+6,5))
				pingstime(100)=Time
			Elseif Instr(lin,"100% packet loss") Then
				up=0
			End If
		Loop
	Close #ff
End Sub

Sub TServer.Http()
	Dim As String lin,part1,part2
	Dim As UByte count
	Var ff=FreeFile
	If proxy="" Then
		Open Pipe "httping -h "+gethttp For Input As #ff
	Else
		Open Pipe "httping -h "+gethttp+" -x "+proxy+" -c 1" For Input As #ff
	End If
		count=0
		Do Until Eof(ff)
			Line Input #ff,lin
			If Instr(lin,"time=") Then
				'pings(99)=pings(100)
				For i As Integer=1 To 99
					httppings(i)=httppings(i+1)
					httppingstime(i)=httppingstime(i+1)
				Next
				part1=Mid(lin,Instr(lin,"time=")+7,1)
				part2=Mid(lin,Instr(lin,"time=")+9,1)
				httppings(100)=Val(part1+"."+part2)
				httppingstime(100)=Time
			Elseif Instr(lin,"100% packet loss") Then
				up=0
			End If
		Loop
	Close #ff
End Sub

Function TServer.CheckPorts(check As String)As UByte
	For i As Integer=1 To 9
		If Mid(ports(i),1,Len(check))=check Then Return 1:Exit Function
	Next
	Return 0
End Function

Sub TServer.DrawWin(y As UShort)
	Dim As UByte checki
	
	Line (0,y+1)-(100,y+19),RGB(0,102,204),BF
	Line (120,y+1)-(230,y+19),RGB(0,102,204),BF
	Color RGB(245,255,255)
	Draw String (20,y+3),"Neuladen"
	Draw String (128,y+3),"Ping alle "+Str(pinginterval)+"s"
	If MouseX>20 And MouseX<100 And MouseY>y And MouseY<y+19 Then
		Line (0,y+1)-(100,y+19),RGB(245,255,255),BF
		Color RGB(1,1,1)
		Draw String (20,y+3),"Neuladen"
		If MouseB=1 And keytim<Timer-1 Then
			Refresh()
			keytim=Timer
		End If
	ElseIf MouseX>120 And MouseX<230 And MouseY>y And MouseY<y+19 Then
		Line (120,y+1)-(230,y+19),RGB(245,255,255),BF
		Color RGB(1,1,1)
		Draw String (128,y+3),"Ping alle "+Str(pinginterval)+"s"
		If MouseB=1 And keytim<Timer-0.25 Then
			pinginterval+=1
			If pinginterval>10 Then pinginterval=1
			keytim=Timer
		End If
	End If
	'If gethttp<>"" Then
		'Line (250,y+1)-(350,y+19),RGB(0,102,204),BF
		'Color RGB(245,255,255)
		'If graph=0 Then
			'Draw String (260,y+3),"HTTP Graph"
		'Elseif graph=1 Then
			'Draw String (260,y+3),"HTTP+Ping"
		'Elseif graph=2 Then
			'Draw String (264,y+3),"Ping Graph"
		'End If
		'If MouseX>250 And MouseX<1350 And MouseY>y And MouseY<y+19 Then
			'Line (250,y+1)-(350,y+19),RGB(245,255,255),BF
			'Color RGB(1,1,1)
			'If graph=0 Then
				'Draw String (260,y+3),"HTTP Graph"
			'Elseif graph=1 Then
				'Draw String (260,y+3),"HTTP+Ping"
			'Elseif graph=2 Then
				'Draw String (264,y+3),"Ping Graph"
			'End If
			'If MouseB=1 And keytim<Timer-1 Then
				'graph+=1
				'If graph=3 Then graph=0
				'For i As Integer=1 To 100
					'pings(i)=0
					'pingstime(i)=""
				'Next
				'keytim=Timer
			'End If
		'End If
	'End If
	Color RGB(245,255,255)
	Draw String (10,y+20),"Name:  "+nam
	Draw String (10,y+35),"Alias: "+aliasname
	Draw String (10,y+50),"IP:    "+IP
	Line (0,y+65)-(400,y+65),RGB(136,139,139)
	Draw String (10,y+67),"NMAP:"
	For i As Integer=1 To 9
		Color RGB(245,255,255)
		If ports(i)<>"" Then Draw String (70,y+52+i*15),ports(i)
		If Mid(ports(i),1,6)="21/tcp" Then 
			Line (300,y+52+i*15)-(390,y+65+i*15),RGB(0,102,204),BF
			Color RGB(245,255,255)
			Draw String (306,y+52+i*15),"FTP-Client"
			If MouseX>300 And MouseX<390 And MouseY>y+52+i*15 And MouseY<y+66+i*15 Then
				Line (300,y+52+i*15)-(390,y+66+i*15),RGB(245,255,255),BF	
				Color RGB(1,1,1)
				Draw String (306,y+52+i*15),"FTP-Client"
				If MouseB=1 And keytim<Timer-1 Then
					Shell (terminal+" "+Chr(34)+"ftp -nv "+nam+Chr(34))
					keytim=Timer
				End If
			End If
		End If
		If Mid(ports(i),1,6)="22/tcp" Then 
			Line (300,y+52+i*15)-(390,y+66+i*15),RGB(0,102,204),BF
			Color RGB(245,255,255)
			Draw String (306,y+52+i*15),"SSH-Client"
			If MouseX>300 And MouseX<390 And MouseY>y+52+i*15 And MouseY<y+66+i*15 Then
				Line (300,y+52+i*15)-(390,y+66+i*15),RGB(245,255,255),BF	
				Color RGB(1,1,1)
				Draw String (306,y+52+i*15),"SSH-Client"
				If MouseB=1 And keytim<Timer-1 Then
					Shell (terminal+" "+Chr(34)+"ssh -X root@"+nam+Chr(34))
					keytim=Timer
				End If
			End If
		End If
		If ports(i)<>"" Then checki=i
	Next
	
	For i As Integer=1 To 9
		If CheckPorts(checkport(i))=0 Then checki+=1:Color RGB(224,108,117):Draw String (70,y+52+checki*15),checkport(i)+" fehlt"
	Next
	
	If up=0 Then Color RGB(224,108,117):Draw String (70,y+67),"Host nicht erreichbar"
	
	Line (0,y-3)-(Xmax,y-3),RGB(136,139,139)
	Line (0,y)-(Xmax,y),RGB(136,139,139)
	Line (400,y)-(400,y+197),RGB(136,139,139)
	
	' ############# PING ############
	
	Line (401,y+1)-(Xmax,y+196),RGB(255,255,255),BF
	
	If gethttp="" Then
		If pingtimer<Timer-pinginterval And up=1 Then Ping():pingtimer=Timer
	Else
		If pingtimer<Timer-pinginterval And up=1 Then Ping():HTTP():pingtimer=Timer
	End If
	
	Dim As Double multi,httpmulti
	multi=0
	httpmulti=0
	For i As Integer=1 To 100
		If pings(i)>multi Then multi=pings(i)
		If gethttp<>"" Then
			If httppings(i)>httpmulti Then httpmulti=httppings(i)
		End If
	Next
	If gethttp="" Then
		Color RGB(0,0,0)
		Draw String (405,y+182),"0 ms"
		Draw String (405,y+2),Format(multi,"0.#")+" ms"
	End If
	multi=190/multi
	If gethttp<>"" Then httpmulti=85/httpmulti
	Line (401,y+196-pings(100)*multi)-(800,y+196-pings(100)*multi),RGB(136,139,139),,&hFF00
	If gethttp<>"" Then Line (401,y+196-httppings(100)*httpmulti)-(800,y+196-httppings(100)*httpmulti),RGB(136,139,139),,&hFF00
	
	Color RGB(0,200,0)
	Draw String (710,y+196-pings(100)*multi),"Ping "+Format(pings(100),"0.##")+" ms"
	
	If gethttp<>"" Then 
		Color RGB(200,0,0)
		Draw String (710,y+196-httppings(100)*httpmulti),"HTTP "+Format(httppings(100),"0.##")+" ms"
	End If
	
	For i As Integer=2 To 100
		Line (450+i*3,y+196-pings(i)*multi)-(450+(i-1)*3,y+196-pings(i-1)*multi),RGB(0,200,0)
		If gethttp<>"" Then Line (450+i*3,y+196-httppings(i)*httpmulti)-(450+(i-1)*3,y+196-httppings(i-1)*httpmulti),RGB(200,0,0)
	Next
	
	For i As Integer=2 To 100
		If MouseY>y And MouseY<y+200 Then
			If MouseX>450+i*3-2 And MouseX<450+i*3+2 And pings(i)<>0 Then
				Line (450+i*3,y)-(450+i*3,y+196),RGB(136,139,139)
				If gethttp="" Then
					Line (MouseX+10,MouseY-2)-(MouseX+14+Len(pingstime(i))*8,MouseY+30),RGB(136,139,139),BF
					Color RGB(1,1,1)
					Draw String (MouseX+12,MouseY),Format(pings(i),"0.##")+" ms"
					Draw String (MouseX+12,MouseY+15),pingstime(i)
				Else
					Line (MouseX+10,MouseY-2)-(MouseX+22+Len(Format(httppings(i),"0.##")+" ms HTTP")*8,MouseY+45),RGB(136,139,139),BF
					Color RGB(1,1,1)
					Draw String (MouseX+12,MouseY),Format(pings(i),"0.##")+" ms Ping"
					Draw String (MouseX+12,MouseY+15),Format(httppings(i),"0.##")+" ms HTTP"
					Draw String (MouseX+12,MouseY+30),pingstime(i)
				End If
			End If
		End If
	Next
End Sub

Dim Shared As TServer Server(5)

Sub AddServer(nam As String)
	With Server(server_anzahl)
		.nam=nam
		.Refresh()
		.pingtimer=server_anzahl
		.pinginterval=3
	End With
	server_anzahl+=1
End Sub

'Var ff=FreeFile
'Dim As String lin
'Open "serverlist.cfg" For Input As #ff
	'Do Until Eof(ff)
		'Line Input #ff,lin
		'If Instr (lin,"#") Then
		
		'Else
			'AddServer(lin)
		'End If
	'Loop
'Close #ff

Var ff=FreeFile
Dim As String lin
Dim As UByte portnum
Open "server-test.cfg" For Input As #ff
	Line Input #ff,terminal
	terminal=Mid(terminal,10)
	Line Input #ff,proxy
	proxy=Mid(proxy,7)
	Do Until Eof(ff)
		Line Input #ff,lin
		If Instr (lin,"#") Then
		
		Elseif Mid(lin,1,5)="port=" Then
			portnum+=1
			Server(server_anzahl-1).checkport(portnum)=Mid(lin,6)
		Elseif Mid(lin,1,5)="http=" Then
			Server(server_anzahl-1).gethttp=Mid(lin,6)
		Else
			AddServer(lin)
			portnum=0
		End If
	Loop
Close #ff

